import { DOT_SERVICE_EVENT_TYPE_SHOW_ATTACHMENT_VIEWER, DOT_SERVICE_EVENT_TYPE_HIDE_ATTACHMENT_VIEWER } from '../../../service/helpers/constant';
import { DUMMY_OBJECT } from '../../../utils/constants';
import objectManager from '../../../utils/objectManager';
const {
  setObjectValue: _showAttachment,
  clearObjectValue: _clearAttachment,
  getObject: _getAttachmentData
} = objectManager();

const attachmentViewerReducer = function () {
  let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DUMMY_OBJECT;
  let action = arguments.length > 1 ? arguments[1] : undefined;
  const {
    type,
    payload
  } = action;

  switch (type) {
    case DOT_SERVICE_EVENT_TYPE_SHOW_ATTACHMENT_VIEWER:
      _showAttachment(payload);

      return _getAttachmentData();

    case DOT_SERVICE_EVENT_TYPE_HIDE_ATTACHMENT_VIEWER:
      _clearAttachment();

      return _getAttachmentData();

    default:
      console.error('No such service found in DOT Attachment Viewer Service');
      return state;
  }
};

export default attachmentViewerReducer;