import { DOT_SERVICE_EVENT, DOT_SERVICE_EVENT_TYPE_SHOW_TOAST_NOTIFICATION, DOT_SERVICE_EVENT_TYPE_HIDE_TOAST_NOTIFICATION, DOT_SERVICE_EVENT_TYPE_CLEAR_ALL_TOAST_NOTIFICATION, DOT_SERVICE_EVENT_TYPE_SHOW_PROMISE_TOAST_NOTIFICATION, DOT_SERVICE_EVENT_TYPE_UPDATE_PROMISE_TOAST_NOTIFICATION, DOT_SERVICE_EVENT_TYPE_HIDE_PROMISE_TOAST_NOTIFICATION } from "./constant";
import { dispatchCustomEvent } from "../../utils/customEventDispatcher";
export function showToastNotification(payload) {
  dispatchCustomEvent({
    eventName: DOT_SERVICE_EVENT,
    detail: {
      type: DOT_SERVICE_EVENT_TYPE_SHOW_TOAST_NOTIFICATION,
      payload
    }
  });
}
export function hideToastNotification(id) {
  dispatchCustomEvent({
    eventName: DOT_SERVICE_EVENT,
    detail: {
      type: DOT_SERVICE_EVENT_TYPE_HIDE_TOAST_NOTIFICATION,
      payload: {
        id
      }
    }
  });
}
export function clearToastNotifications() {
  dispatchCustomEvent({
    eventName: DOT_SERVICE_EVENT,
    detail: {
      type: DOT_SERVICE_EVENT_TYPE_CLEAR_ALL_TOAST_NOTIFICATION // Removed trailing comma

    }
  });
}
export function showPromiseToastNotification(payload) {
  dispatchCustomEvent({
    eventName: DOT_SERVICE_EVENT,
    detail: {
      type: DOT_SERVICE_EVENT_TYPE_SHOW_PROMISE_TOAST_NOTIFICATION,
      payload
    }
  });
}
export function updatePromiseToastNotification(payload) {
  dispatchCustomEvent({
    eventName: DOT_SERVICE_EVENT,
    detail: {
      type: DOT_SERVICE_EVENT_TYPE_UPDATE_PROMISE_TOAST_NOTIFICATION,
      payload
    }
  });
}