import { appendToArray, deleteFromArrayOfObjectById, deleteFromArrayByItem, modifyArrayOfObjectItemById, modifyArrayItemByItem, emptyArray } from './arrayCRUD';
import { DUMMY_ARRAY } from './constants';
let array = DUMMY_ARRAY;

const arrayManager = () => {
  const addItem = item => {
    const modifiedArray = appendToArray({
      array,
      item
    });
    array = modifiedArray; // return modifiedArray
  };

  const removeItemById = id => {
    const modifiedArray = deleteFromArrayOfObjectById({
      arrayOfObject: array,
      id
    });
    array = modifiedArray; // return modifiedArray
  };

  const removeItemByItem = item => {
    const modifiedArray = deleteFromArrayByItem({
      array,
      item
    });
    array = modifiedArray; // return modifiedArray
  };

  const clearItems = () => {
    const modifiedArray = emptyArray();
    array = modifiedArray; // return modifiedArray
  };

  const updateItemById = (id, newItem) => {
    const modifiedArray = modifyArrayOfObjectItemById({
      arrayOfObject: array,
      id,
      newItem
    });
    array = modifiedArray; // return modifiedArray
  };

  const updateItemByItem = (currentItem, newItem) => {
    const modifiedArray = modifyArrayItemByItem({
      array,
      currentItem,
      newItem
    });
    array = modifiedArray; // return modifiedArray
  };

  return {
    addItem,
    removeItemById,
    removeItemByItem,
    clearItems,
    updateItemById,
    updateItemByItem,
    getArray: () => array
  };
};

export default arrayManager;