import { emptyObject, mergeObjects, updateObjectValueByKey as _updateObjectValueByKey, removeObjectByKey as _removeObjectByKey, removeObjectByKeys as _removeObjectByKeys } from './objectCRUD';
import { DUMMY_OBJECT } from './constants';
let object = DUMMY_OBJECT;

const objectManager = () => {
  const setObjectValue = newObject => {
    const modifiedObject = mergeObjects({
      object,
      newObject
    });
    object = modifiedObject;
  };

  const clearObjectValue = () => {
    const modifiedObject = emptyObject();
    object = modifiedObject;
  };

  const updateObjectValueByKey = (key, value) => {
    const modifiedObject = _updateObjectValueByKey({
      object,
      key,
      value
    });

    object = modifiedObject;
  };

  const removeObjectByKeys = keys => {
    const modifiedObject = _removeObjectByKeys({
      object,
      keys
    });

    object = modifiedObject;
  };

  const removeObjectByKey = key => {
    const modifiedObject = _removeObjectByKey({
      object,
      key
    });

    object = modifiedObject;
  };

  return {
    setObjectValue,
    clearObjectValue,
    updateObjectValueByKey,
    removeObjectByKeys,
    removeObjectByKey,
    getObject: () => object
  };
};

export default objectManager;