"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _selectn2 = _interopRequireDefault(require("selectn"));

var _react = require("react");

var _customEventDispatcher = require("../../../utils/customEventDispatcher");

var _constant = require("../../../service/helpers/constant");

var _attachmentViewerReducer = _interopRequireDefault(require("../reducers/attachmentViewerReducer"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var useDOTAttachmentViewerService = function useDOTAttachmentViewerService() {
  var _useReducer = (0, _react.useReducer)(_attachmentViewerReducer["default"]),
      _useReducer2 = _slicedToArray(_useReducer, 2),
      attachment = _useReducer2[0],
      dispatch = _useReducer2[1];

  var handleService = function handleService(event) {
    var _selectn = (0, _selectn2["default"])('detail', event),
        type = _selectn.type,
        payload = _selectn.payload;

    dispatch({
      type: type,
      payload: payload
    });
  };

  (0, _react.useEffect)(function () {
    (0, _customEventDispatcher.addCustomEventListener)({
      eventName: _constant.DOT_SERVICE_EVENT,
      callback: handleService
    });
    return function () {
      (0, _customEventDispatcher.removeCustomEventListener)({
        eventName: _constant.DOT_SERVICE_EVENT,
        callback: handleService
      });
    };
  }, []);
  return {
    attachment: attachment
  };
};

var _default = useDOTAttachmentViewerService;
exports["default"] = _default;