"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = require("react");

var _selectn = _interopRequireDefault(require("selectn"));

var _customEventDispatcher = require("../../../utils/customEventDispatcher");

var _constant = require("../../../service/helpers/constant");

var _toastNotificationReducer = _interopRequireDefault(require("../reducers/toastNotificationReducer"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var toastIdCounter = 0;

var useDOTToastNotificationService = function useDOTToastNotificationService() {
  var _useReducer = (0, _react.useReducer)(_toastNotificationReducer["default"]),
      _useReducer2 = _slicedToArray(_useReducer, 2),
      notifications = _useReducer2[0],
      dispatch = _useReducer2[1];

  var handleService = function handleService(event) {
    if ((0, _selectn["default"])('detail.payload.promise', event)) {
      handlePromiseToast(_objectSpread({
        dispatch: dispatch
      }, (0, _selectn["default"])('detail.payload', event)));
    } else {
      var type = (0, _selectn["default"])('detail.type', event);
      var payload = (0, _selectn["default"])('detail.payload', event);
      var id = "toast".concat(toastIdCounter++);
      var toastMessage = {
        type: type,
        payload: _objectSpread({
          id: id
        }, payload)
      };
      dispatch(toastMessage);
    }
  };

  var handlePromiseToast = function handlePromiseToast(_ref) {
    var dispatch = _ref.dispatch,
        promise = _ref.promise,
        success = _ref.success,
        error = _ref.error,
        loading = _ref.loading,
        onStatusChange = _ref.onStatusChange;
    var id = "promiseToast".concat(toastIdCounter++);

    var loadingToast = _objectSpread({
      id: id,
      type: _constant.DOT_TOAST_NOTIFICATION_TYPE_PRIMARY
    }, loading);

    if (typeof onStatusChange == 'function') {
      loadingToast.onStatusChange = onStatusChange;
    }

    dispatch({
      type: _constant.DOT_SERVICE_EVENT_TYPE_SHOW_PROMISE_TOAST_NOTIFICATION,
      payload: loadingToast
    });
    promise.then(function () {
      var successToast = _objectSpread({
        id: id,
        type: _constant.DOT_TOAST_NOTIFICATION_TYPE_SUCCESS
      }, success);

      if (typeof onStatusChange == 'function') {
        successToast.onStatusChange = onStatusChange;
      }

      dispatch({
        type: _constant.DOT_SERVICE_EVENT_TYPE_UPDATE_PROMISE_TOAST_NOTIFICATION,
        payload: successToast
      });
    })["catch"](function () {
      var errorToast = _objectSpread({
        id: id,
        type: _constant.DOT_TOAST_NOTIFICATION_TYPE_ERROR
      }, error);

      if (typeof onStatusChange == 'function') {
        errorToast.onStatusChange = onStatusChange;
      }

      dispatch({
        type: _constant.DOT_SERVICE_EVENT_TYPE_UPDATE_PROMISE_TOAST_NOTIFICATION,
        payload: errorToast
      });
    });
  };

  (0, _react.useEffect)(function () {
    (0, _customEventDispatcher.addCustomEventListener)({
      eventName: _constant.DOT_SERVICE_EVENT,
      callback: handleService
    });
    return function () {
      (0, _customEventDispatcher.removeCustomEventListener)({
        eventName: _constant.DOT_SERVICE_EVENT,
        callback: handleService
      });
    };
  }, []);
  return {
    notifications: notifications
  };
};

var _default = useDOTToastNotificationService;
exports["default"] = _default;