"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _constant = require("../../../service/helpers/constant");

var _constants = require("../../../utils/constants");

var _objectManager2 = _interopRequireDefault(require("../../../utils/objectManager"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _objectManager = (0, _objectManager2["default"])(),
    _showAttachment = _objectManager.setObjectValue,
    _clearAttachment = _objectManager.clearObjectValue,
    _getAttachmentData = _objectManager.getObject;

var attachmentViewerReducer = function attachmentViewerReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _constants.DUMMY_OBJECT;
  var action = arguments.length > 1 ? arguments[1] : undefined;
  var type = action.type,
      payload = action.payload;

  switch (type) {
    case _constant.DOT_SERVICE_EVENT_TYPE_SHOW_ATTACHMENT_VIEWER:
      _showAttachment(payload);

      return _getAttachmentData();

    case _constant.DOT_SERVICE_EVENT_TYPE_HIDE_ATTACHMENT_VIEWER:
      _clearAttachment();

      return _getAttachmentData();

    default:
      console.error('No such service found in DOT Attachment Viewer Service');
      return state;
  }
};

var _default = attachmentViewerReducer;
exports["default"] = _default;