"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _selectn = _interopRequireDefault(require("selectn"));

var _arrayManager2 = _interopRequireDefault(require("../../../utils/arrayManager"));

var _constant = require("../../../service/helpers/constant");

var _constants = require("../../../utils/constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _arrayManager = (0, _arrayManager2["default"])(),
    _showToastNotification = _arrayManager.addItem,
    _hideToastNotification = _arrayManager.removeItemById,
    _clearToastNotifications = _arrayManager.clearItems,
    _updateToastNotifications = _arrayManager.updateItemById,
    _getToastNotifications = _arrayManager.getArray;

function modifyPayload(payload) {
  var modifiedPayload = _objectSpread({}, payload);

  var id = (0, _selectn["default"])('id', modifiedPayload);
  delete modifiedPayload.id;
  return {
    id: id,
    data: modifiedPayload
  };
}

function getPayload(payload) {
  return modifyPayload(payload);
}

var toastNotificationReducer = function toastNotificationReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _constants.DUMMY_ARRAY;
  var action = arguments.length > 1 ? arguments[1] : undefined;
  var type = action.type,
      payload = action.payload;

  switch (type) {
    case _constant.DOT_SERVICE_EVENT_TYPE_SHOW_TOAST_NOTIFICATION:
      {
        var modifiedPayload = getPayload(payload);

        _showToastNotification(modifiedPayload);

        return _getToastNotifications();
      }

    case _constant.DOT_SERVICE_EVENT_TYPE_HIDE_TOAST_NOTIFICATION:
      {
        var id = (0, _selectn["default"])('id', payload);

        _hideToastNotification(id);

        return _getToastNotifications();
      }

    case _constant.DOT_SERVICE_EVENT_TYPE_CLEAR_ALL_TOAST_NOTIFICATION:
      {
        _clearToastNotifications();

        return _getToastNotifications();
      }

    case _constant.DOT_SERVICE_EVENT_TYPE_SHOW_PROMISE_TOAST_NOTIFICATION:
      {
        var _getPayload = getPayload(payload),
            _id = _getPayload.id,
            data = _getPayload.data;

        _showToastNotification({
          id: _id,
          data: _objectSpread(_objectSpread({}, data), {}, {
            canAutoClose: false
          })
        });

        return _getToastNotifications();
      }

    case _constant.DOT_SERVICE_EVENT_TYPE_UPDATE_PROMISE_TOAST_NOTIFICATION:
      {
        var _getPayload2 = getPayload(payload),
            _id2 = _getPayload2.id,
            _data = _getPayload2.data;

        _updateToastNotifications(_id2, {
          data: _data
        });

        return _getToastNotifications();
      }

    case _constant.DOT_SERVICE_EVENT_TYPE_HIDE_PROMISE_TOAST_NOTIFICATION:
      {
        var _id3 = (0, _selectn["default"])('id', payload);

        _hideToastNotification(_id3);

        return _getToastNotifications();
      }

    default:
      console.error('No such service found in DOT Toast Notification Service');
      return state;
  }
};

var _default = toastNotificationReducer;
exports["default"] = _default;