"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.modifyArrayOfObjectItemById = exports.modifyArrayItemByItem = exports.emptyArray = exports.deleteFromArrayOfObjectById = exports.deleteFromArrayByItem = exports.appendToArray = void 0;

var _deepEqual = require("./deepEqual");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var appendToArray = function appendToArray(_ref) {
  var array = _ref.array,
      item = _ref.item;
  return [].concat(_toConsumableArray(array), [item]);
};

exports.appendToArray = appendToArray;

var modifyArrayOfObjectItemById = function modifyArrayOfObjectItemById(_ref2) {
  var arrayOfObject = _ref2.arrayOfObject,
      id = _ref2.id,
      newItem = _ref2.newItem;
  var found = false;
  return arrayOfObject.map(function (object) {
    if (!found && id !== undefined && object.id === id) {
      found = true;
      return Array.isArray(newItem) ? _toConsumableArray(newItem) : _typeof(newItem) === 'object' ? _objectSpread(_objectSpread({}, object), newItem) : newItem;
    }

    return object;
  });
};

exports.modifyArrayOfObjectItemById = modifyArrayOfObjectItemById;

var modifyArrayItemByItem = function modifyArrayItemByItem(_ref3) {
  var array = _ref3.array,
      currentItem = _ref3.currentItem,
      newItem = _ref3.newItem;
  var found = false;
  return array.map(function (arrayItem) {
    if (!found && currentItem !== undefined && (0, _deepEqual.deepEqual)(arrayItem, currentItem)) {
      found = true;
      return newItem;
    }

    return arrayItem;
  });
};

exports.modifyArrayItemByItem = modifyArrayItemByItem;

var deleteFromArrayOfObjectById = function deleteFromArrayOfObjectById(_ref4) {
  var arrayOfObject = _ref4.arrayOfObject,
      id = _ref4.id;
  var found = false;
  return arrayOfObject.filter(function (object) {
    if (!found && id !== undefined && object.id === id) {
      found = true;
      return false;
    }

    return true;
  });
};

exports.deleteFromArrayOfObjectById = deleteFromArrayOfObjectById;

var deleteFromArrayByItem = function deleteFromArrayByItem(_ref5) {
  var array = _ref5.array,
      currentItem = _ref5.currentItem;
  var found = false;
  return array.filter(function (arrayItem) {
    if (!found && currentItem !== undefined && (0, _deepEqual.deepEqual)(arrayItem, currentItem)) {
      found = true;
      return false;
    }

    return true;
  });
};

exports.deleteFromArrayByItem = deleteFromArrayByItem;

var emptyArray = function emptyArray() {
  return [];
};

exports.emptyArray = emptyArray;