"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _arrayCRUD = require("./arrayCRUD");

var _constants = require("./constants");

var array = _constants.DUMMY_ARRAY;

var arrayManager = function arrayManager() {
  var addItem = function addItem(item) {
    var modifiedArray = (0, _arrayCRUD.appendToArray)({
      array: array,
      item: item
    });
    array = modifiedArray; // return modifiedArray
  };

  var removeItemById = function removeItemById(id) {
    var modifiedArray = (0, _arrayCRUD.deleteFromArrayOfObjectById)({
      arrayOfObject: array,
      id: id
    });
    array = modifiedArray; // return modifiedArray
  };

  var removeItemByItem = function removeItemByItem(item) {
    var modifiedArray = (0, _arrayCRUD.deleteFromArrayByItem)({
      array: array,
      item: item
    });
    array = modifiedArray; // return modifiedArray
  };

  var clearItems = function clearItems() {
    var modifiedArray = (0, _arrayCRUD.emptyArray)();
    array = modifiedArray; // return modifiedArray
  };

  var updateItemById = function updateItemById(id, newItem) {
    var modifiedArray = (0, _arrayCRUD.modifyArrayOfObjectItemById)({
      arrayOfObject: array,
      id: id,
      newItem: newItem
    });
    array = modifiedArray; // return modifiedArray
  };

  var updateItemByItem = function updateItemByItem(currentItem, newItem) {
    var modifiedArray = (0, _arrayCRUD.modifyArrayItemByItem)({
      array: array,
      currentItem: currentItem,
      newItem: newItem
    });
    array = modifiedArray; // return modifiedArray
  };

  return {
    addItem: addItem,
    removeItemById: removeItemById,
    removeItemByItem: removeItemByItem,
    clearItems: clearItems,
    updateItemById: updateItemById,
    updateItemByItem: updateItemByItem,
    getArray: function getArray() {
      return array;
    }
  };
};

var _default = arrayManager;
exports["default"] = _default;