"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deepEqual = void 0;

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

var deepEqual = function deepEqual(a, b) {
  if (a === b) {
    return true;
  }

  if (_typeof(a) === 'object' && _typeof(b) === 'object' && a !== null && b !== null) {
    if (Array.isArray(a) !== Array.isArray(b)) {
      return false;
    }

    var keysA = Object.keys(a);
    var keysB = Object.keys(b);

    if (keysA.length !== keysB.length) {
      return false;
    }

    return keysA.every(function (key) {
      return deepEqual(a[key], b[key]);
    });
  }

  if (typeof a === 'function' && typeof b === 'function') {
    return a.toString().replace(/\s+/g, '') === b.toString().replace(/\s+/g, '');
  }

  return false;
};

exports.deepEqual = deepEqual;