"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.updateObjectValueByKey = exports.removeObjectByKeys = exports.removeObjectByKey = exports.mergeObjects = exports.emptyObject = void 0;

var _constants = require("./constants");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var mergeObjects = function mergeObjects(_ref) {
  var object = _ref.object,
      newObject = _ref.newObject;
  return _objectSpread(_objectSpread({}, object), newObject);
};

exports.mergeObjects = mergeObjects;

var emptyObject = function emptyObject() {
  return _constants.DUMMY_OBJECT;
};

exports.emptyObject = emptyObject;

var updateObjectValueByKey = function updateObjectValueByKey(_ref2) {
  var object = _ref2.object,
      key = _ref2.key,
      value = _ref2.value;
  return _objectSpread(_objectSpread({}, object), {}, _defineProperty({}, key, value));
};

exports.updateObjectValueByKey = updateObjectValueByKey;

var removeObjectByKeys = function removeObjectByKeys(_ref3) {
  var object = _ref3.object,
      keys = _ref3.keys;

  var newObject = _objectSpread({}, object);

  if (Array.isArray(keys)) {
    keys.forEach(function (key) {
      delete newObject[key];
    });
  }

  return newObject;
};

exports.removeObjectByKeys = removeObjectByKeys;

var removeObjectByKey = function removeObjectByKey(_ref4) {
  var object = _ref4.object,
      key = _ref4.key;

  var newObject = _objectSpread({}, object);

  delete newObject[key];
  return newObject;
};

exports.removeObjectByKey = removeObjectByKey;