"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectCRUD = require("./objectCRUD");

var _constants = require("./constants");

var object = _constants.DUMMY_OBJECT;

var objectManager = function objectManager() {
  var setObjectValue = function setObjectValue(newObject) {
    var modifiedObject = (0, _objectCRUD.mergeObjects)({
      object: object,
      newObject: newObject
    });
    object = modifiedObject;
  };

  var clearObjectValue = function clearObjectValue() {
    var modifiedObject = (0, _objectCRUD.emptyObject)();
    object = modifiedObject;
  };

  var updateObjectValueByKey = function updateObjectValueByKey(key, value) {
    var modifiedObject = (0, _objectCRUD.updateObjectValueByKey)({
      object: object,
      key: key,
      value: value
    });
    object = modifiedObject;
  };

  var removeObjectByKeys = function removeObjectByKeys(keys) {
    var modifiedObject = (0, _objectCRUD.removeObjectByKeys)({
      object: object,
      keys: keys
    });
    object = modifiedObject;
  };

  var removeObjectByKey = function removeObjectByKey(key) {
    var modifiedObject = (0, _objectCRUD.removeObjectByKey)({
      object: object,
      key: key
    });
    object = modifiedObject;
  };

  return {
    setObjectValue: setObjectValue,
    clearObjectValue: clearObjectValue,
    updateObjectValueByKey: updateObjectValueByKey,
    removeObjectByKeys: removeObjectByKeys,
    removeObjectByKey: removeObjectByKey,
    getObject: function getObject() {
      return object;
    }
  };
};

var _default = objectManager;
exports["default"] = _default;